import 'package:diplomaticquarterapp/core/viewModels/medical/blood_pressure_view_model.dart';
import 'package:diplomaticquarterapp/core/viewModels/project_view_model.dart';
import 'package:diplomaticquarterapp/pages/medical/my_trackers/widget/CurvedChartBloodPressure.dart';
import 'package:diplomaticquarterapp/uitl/date_uitl.dart';
import 'package:diplomaticquarterapp/uitl/translations_delegate_base.dart';
import 'package:diplomaticquarterapp/widgets/charts/app_time_series_chart.dart';
import 'package:diplomaticquarterapp/widgets/data_display/text.dart';
import 'package:diplomaticquarterapp/widgets/others/app_scaffold_widget.dart';
import 'package:diplomaticquarterapp/widgets/transitions/fade_page.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

import 'AddBloodPressurePage.dart';

class BloodPressureWeeklyPage extends StatelessWidget {
  final BloodPressureViewMode model;

  const BloodPressureWeeklyPage({Key key, this.model}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    ProjectViewModel projectViewModel = Provider.of(context);
    return AppScaffold(
      body:  ListView(
        children: [
          Container(
            margin: EdgeInsets.only(top: 12, left: 8, right: 8),
            color: Colors.white,
            child: CurvedChartBloodPressure(
              horizontalInterval:3.0,
              title: TranslationBase.of(context).bloodPressure,
              timeSeries1: model.weightWeekTimeSeriesDataTop.isEmpty?[TimeSeriesSales2(DateTime.now(),0.0)]:model.weightWeekTimeSeriesDataTop,
              timeSeries2: model.weightWeekTimeSeriesDataLow.isEmpty?[TimeSeriesSales2(DateTime.now(),0.0)]:model.weightWeekTimeSeriesDataLow,
              indexes: model.weightWeekTimeSeriesDataLow.length ~/ 5.5,
            ),
          ),
          SizedBox(
            height: 12,
          ),
          Padding(
            padding: const EdgeInsets.all(8.0),
            child: Texts(TranslationBase.of(context).details),
          ),
          Container(
            padding: EdgeInsets.all(10),
            color: Colors.transparent,
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: <Widget>[
                model.weightWeekTimeSeriesDataTop.isEmpty? Container(child: Center(child: Texts(TranslationBase.of(context).noDataAvailable),),): Table(
                  border: TableBorder.symmetric(
                    inside: BorderSide(width: 2.0, color: Colors.grey[300]),
                  ),
                  children: fullData(context, projectViewModel, model),
                ),
              ],
            ),
          )
        ],
      ),
    );
  }

  List<TableRow> fullData(
      BuildContext context,
      ProjectViewModel projectViewModel,
      BloodPressureViewMode bloodSugarViewMode) {
    List<TableRow> tableRow = [];
    tableRow.add(
      TableRow(
        children: [
          Container(
            child: Container(
              decoration: BoxDecoration(
                color: Theme.of(context).primaryColor,
                borderRadius: BorderRadius.only(
                  topLeft: projectViewModel.isArabic
                      ? Radius.circular(0.0)
                      : Radius.circular(10.0),
                  topRight: projectViewModel.isArabic
                      ? Radius.circular(10.0)
                      : Radius.circular(0.0),
                ),
              ),
              child: Center(
                child: Texts(
                  TranslationBase.of(context).date,
                  color: Colors.white,
                  fontSize: 15,
                ),
              ),
              height: 40,
            ),
          ),
          Container(
            child: Container(
                decoration: BoxDecoration(
                  color: Theme.of(context).primaryColor,
                ),
                child: Center(
                  child: Texts(
                    TranslationBase.of(context).time,
                    color: Colors.white,
                    fontSize: 15,
                  ),
                ),
                height: 40),
          ),
          Container(
            child: Container(
                decoration: BoxDecoration(
                  color: Theme.of(context).primaryColor,
                ),
                child: Center(
                  child: Texts(
                    TranslationBase.of(context).measured,
                    color: Colors.white,
                    fontSize: 15,
                  ),
                ),
                height: 40),
          ),
          Container(
            child: Container(
                decoration: BoxDecoration(
                  color: Theme.of(context).primaryColor,
                ),
                child: Center(
                  child: Texts(
                    TranslationBase.of(context).value,
                    color: Colors.white,
                    fontSize: 15,
                  ),
                ),
                height: 40),
          ),
          Container(
            child: Container(
                decoration: BoxDecoration(
                  color: Theme.of(context).primaryColor,
                  borderRadius: BorderRadius.only(
                    topLeft: projectViewModel.isArabic
                        ? Radius.circular(10.0)
                        : Radius.circular(0.0),
                    topRight: projectViewModel.isArabic
                        ? Radius.circular(0.0)
                        : Radius.circular(10.0),
                  ),
                ),
                child: Center(
                  child: Texts(
                    TranslationBase.of(context).edit,
                    color: Colors.white,
                    fontSize: 15,
                  ),
                ),
                height: 40),
          ),
        ],
      ),
    );
    model.weekDiabtecPatientResult.reversed.forEach(
      (diabtec) {
        tableRow.add(
          TableRow(
            children: [
              Container(
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Texts(
                      '${DateUtil.getMonthDayYearDateFormatted(diabtec.bloodPressureDate)} ',
                      textAlign: TextAlign.center,
                      fontSize: 12,
                    ),
                  ),
                ),
              ),
              Container(
                height: 70,
                padding: EdgeInsets.all(10),
                color: Colors.white,
                child: Center(
                  child: Texts(
                    '${diabtec.bloodPressureDate.hour}:${diabtec.bloodPressureDate.minute}',
                    textAlign: TextAlign.center,
                    fontSize: 12,
                  ),
                ),
              ),
              Container(
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Texts(
                      '${diabtec.measuredArmDesc}',
                      textAlign: TextAlign.center,
                      fontSize: 12,
                    ),
                  ),
                ),
              ),
              Container(
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Texts(
                      '${diabtec.systolicePressure}/${diabtec.diastolicPressure}',
                      textAlign: TextAlign.center,
                      fontSize: 12,
                      color: Colors.red,
                    ),
                  ),
                ),
              ),
              InkWell(
                onTap: () {
                  Navigator.push(
                    context,
                    FadePage(
                      page: AddBloodPressurePage(
                        model: model,
                        isUpdate: true,
                        lineItemNo: diabtec.lineItemNo,
                        bloodSugarDate: diabtec.bloodPressureDate,
                        bloodDiastolicValue: diabtec.diastolicPressure.toString(),
                        bloodSystolicValue: diabtec.systolicePressure.toString(),
                        measureTimeSelectedType: diabtec.measuredArmDesc,
                      ),
                    ),
                  );
                },
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Icon(Icons.edit),
                  ),
                ),
              ),
            ],
          ),
        );
      },
    );
    return tableRow;
  }
}
